"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleConst = require("@cloudflare/style-const");

var _styleContainer = require("@cloudflare/style-container");

var _polished = require("polished");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var hueColors = function hueColors(hue) {
  switch (hue) {
    case 'red':
      return (0, _styleConst.isDarkMode)() ? {
        backgroundColor: 'red.3',
        color: 'gray.9'
      } : {
        backgroundColor: 'red.8',
        color: 'red.1'
      };

    case 'blue':
      return (0, _styleConst.isDarkMode)() ? {
        backgroundColor: 'blue.3',
        color: 'blue.9'
      } : {
        backgroundColor: 'blue.8',
        color: 'blue.1'
      };

    case 'green':
      return (0, _styleConst.isDarkMode)() ? {
        backgroundColor: 'green.3',
        color: 'gray.9'
      } : {
        backgroundColor: 'green.8',
        color: 'green.0'
      };

    case 'orange':
      return (0, _styleConst.isDarkMode)() ? {
        backgroundColor: 'orange.2',
        color: 'gray.9'
      } : {
        backgroundColor: 'orange.8',
        color: 'orange.1'
      };

    default:
      return (0, _styleConst.isDarkMode)() ? {
        backgroundColor: 'gray.2',
        color: 'gray.9'
      } : {
        backgroundColor: 'gray.8',
        color: 'gray.1'
      };
  }
};

var toHexString = function toHexString(themeColor, theme) {
  var _themeColor$split = themeColor.split('.'),
      _themeColor$split2 = _slicedToArray(_themeColor$split, 2),
      color = _themeColor$split2[0],
      scale = _themeColor$split2[1];

  return theme.colors[color][scale];
};

var styles = function styles(_ref) {
  var theme = _ref.theme,
      _ref$hue = _ref.hue,
      hue = _ref$hue === void 0 ? 'gray' : _ref$hue,
      _ref$pulse = _ref.pulse,
      pulse = _ref$pulse === void 0 ? false : _ref$pulse;

  var _hueColors = hueColors(hue),
      color = _hueColors.color,
      backgroundColor = _hueColors.backgroundColor;

  return _objectSpread({
    alignItems: 'center',
    borderRadius: '50px',
    color: color,
    display: 'inline-flex',
    fontSize: 1,
    fontWeight: 400,
    lineHeight: theme.lineHeights.solid,
    userSelect: 'none',
    whiteSpace: 'nowrap',
    px: 2,
    py: 1,
    backgroundColor: backgroundColor
  }, pulse && {
    animationName: {
      '0%': {
        boxShadow: "0 0 0 0 ".concat((0, _polished.transparentize)(0.4, toHexString(backgroundColor, theme)))
      },
      '70%': {
        boxShadow: "0 0 0 10px ".concat((0, _polished.transparentize)(1, toHexString(backgroundColor, theme)))
      },
      '100%': {
        boxShadow: "0 0 0 0 ".concat((0, _polished.transparentize)(1, toHexString(backgroundColor, theme)))
      }
    },
    animationDuration: '2s',
    animationIterationCount: 'infinite'
  });
};

var Label = (0, _styleContainer.createStyledComponent)(styles, 'span');
Label.propTypes = {
  hue: _propTypes.default.oneOf(['green', 'orange', 'red', 'gray', 'blue']).isRequired
};
var _default = Label;
exports.default = _default;